\name{HTML}
\alias{HTML}
\alias{HTML.anova}
\alias{HTML.aov}
\alias{HTML.aovlist}
\alias{HTML.array}
\alias{HTML.atomic}
\alias{HTML.by}
\alias{HTML.call}
\alias{HTML.character}
\alias{HTML.coefmat}
\alias{HTML.complex}
\alias{HTML.connection}
\alias{HTML.default}
\alias{HTML.density}
\alias{HTML.difftime}
\alias{HTML.dummy.coef}
\alias{HTML.dummy.coef.list}
\alias{HTML.environment}
\alias{HTML.factor}
\alias{HTML.family}
\alias{HTML.formula}
\alias{HTML.ftable}
\alias{HTML.glm}
\alias{HTML.glm.null}
\alias{HTML.hsearch}
\alias{HTML.htest}
\alias{HTML.infl}
\alias{HTML.integer}
\alias{HTML.integrate}
\alias{HTML.list}
\alias{HTML.listof}
\alias{HTML.lm}
\alias{HTML.lm.null}
\alias{HTML.logical}
\alias{HTML.logLik}
\alias{HTML.MethodsFunction}
\alias{HTML.mtable}
\alias{HTML.noquote}
\alias{HTML.numeric}
\alias{HTML.octmode}
\alias{HTML.ordered}
\alias{HTML.pairlist}
\alias{HTML.POSIXct}
\alias{HTML.POSIXlt}
\alias{HTML.rle}
\alias{HTML.SavedPlots}
\alias{HTML.simple.list}
\alias{HTML.socket}
\alias{HTML.summary.aov}
\alias{HTML.summary.aovlist}
\alias{HTML.summary.glm}
\alias{HTML.summary.glm.null}
\alias{HTML.summary.lm}
\alias{HTML.summary.lm.null}
\alias{HTML.summary.manova}
\alias{HTML.summary.table}
\alias{HTML.table}
\alias{HTML.tables.aov}
\alias{HTML.terms}
\alias{HTML.ts}
\alias{HTML.TukeyHSD}
\alias{HTML.xtable}
\alias{HTML.xtabs}
\alias{HTML.abbrev}
\alias{HTML.agnes}
\alias{HTML.Anova}
\alias{HTML.anova.loglm}
\alias{HTML.ar}
\alias{HTML.Arima}
\alias{HTML.arima0}
\alias{HTML.boot}
\alias{HTML.bootci}
\alias{HTML.bSpline}
\alias{HTML.clara}
\alias{HTML.correspondence}
\alias{HTML.cox.zph}
\alias{HTML.coxph.null}
\alias{HTML.date}
\alias{HTML.diana}
\alias{HTML.dissimilarity}
\alias{HTML.dist}
\alias{HTML.ecdf}
\alias{HTML.ellipsoid}
\alias{HTML.factanal}
\alias{HTML.fanny}
\alias{HTML.fitdistr}
\alias{HTML.fractions}
\alias{HTML.gam}
\alias{HTML.gamma.shape}
\alias{HTML.glm.dose}
\alias{HTML.grob}
\alias{HTML.hclust}
\alias{HTML.HoltWinters}
\alias{HTML.lda}
\alias{HTML.libraryIQR}
\alias{HTML.loadings}
\alias{HTML.loess}
\alias{HTML.loglm}
\alias{HTML.lqs}
\alias{HTML.mca}
\alias{HTML.medpolish}
\alias{HTML.mona}
\alias{HTML.multinom}
\alias{HTML.nls}
\alias{HTML.nnet}
\alias{HTML.pairwise.htest}
\alias{HTML.pam}
\alias{HTML.polr}
\alias{HTML.polySpline}
\alias{HTML.power.htest}
\alias{HTML.ppolySpline}
\alias{HTML.ppr}
\alias{HTML.prcomp}
\alias{HTML.princomp}
\alias{HTML.qda}
\alias{HTML.ridgelm}
\alias{HTML.rlm}
\alias{HTML.rms.curv}
\alias{HTML.rpart}
\alias{HTML.saddle.distn}
\alias{HTML.shingle}
\alias{HTML.shingleLevel}
\alias{HTML.simplex}
\alias{HTML.smooth.spline}
\alias{HTML.stepfun}
\alias{HTML.stl}
\alias{HTML.StructTS}
\alias{HTML.structure}
\alias{HTML.summary.agnes}
\alias{HTML.summary.clara}
\alias{HTML.summary.diana}
\alias{HTML.summary.fanny}
\alias{HTML.summary.gam}
\alias{HTML.summary.loess}
\alias{HTML.summary.loglm}
\alias{HTML.summary.mona}
\alias{HTML.summary.multinom}
\alias{HTML.summary.negbin}
\alias{HTML.summary.nls}
\alias{HTML.summary.nnet}
\alias{HTML.summary.pam}
\alias{HTML.summary.polr}
\alias{HTML.summary.ppr}
\alias{HTML.summary.prcomp}
\alias{HTML.summary.princomp}
\alias{HTML.summary.rlm}
\alias{HTML.tskernel}
\alias{HTML.tukeyline}
\alias{HTML.tukeysmooth}
\alias{HTML.unit}
\alias{HTML.viewport}  


\title{Outputs an object to a HTML file}
\description{
  
  Generic method equivalent to print that performs HTML output for any R object.
}
\usage{
HTML(x, ...)
}
\arguments{
  \item{x}{ R object to export }
  \item{\dots}{ ...}
}
\details{
 \code{HTML} function acts like \code{cat}, with a \code{file} argument, which has to be used and a \code{append} argument, which is set by default to TRUE. A convenient default value for \code{file} argument is set to hidden variable \code{.HTML.file}, so that one may begin to set this variable and omit the argument thereafter.
 Most of the current classes are handled by \code{HTML} function. Some specific methods such as \code{HTML.matrix} or \code{HTML.data.frame} do own a lot of arguments to precise the way the data are exported.
}
\value{
	no value returned.  
}
\references{ }
\author{ Eric Lecoutre }

\note{ For a discussion about .HTML.file default value for file argument, refer to \code{\link{HTMLStart}} }

\seealso{\code{\link{HTML.data.frame}},\code{\link{HTML.function}},  \code{\link{HTMLStart}}}

\examples{
dir.create(file.path(tempdir(),"R2HTML"))
target <- HTMLInitFile(file.path(tempdir(),"R2HTML"),filename="sample", BackGroundColor="#BBBBEE")
HTML("<br>Don't forget to use the CSS file in order to benefit from fixed size police",file=target)
tmp <- as.data.frame(matrix(rnorm(100),ncol=10))
HTML(tmp,file=target)
HTMLEndFile()
}
\keyword{ print }
\keyword{ IO }
\keyword{ file }


\eof
\name{HTML.cormat}
\alias{HTML.cormat}

\title{ Write a correlation matrix with HTML formatting }
\description{
  Although the class \sQuote{cormat} is not defined, the function is called to \code{HTML.cormat}, to highlight the fact it should be called only with a correlation matrix. 
}
\synopsis{
HTML.cormat(x, file = .HTML.file, digits = 2, append = TRUE, align = "center", caption = "", captionalign = "bottom", classcaption = "captiondataframe", classtable = "cormat", useCSS = TRUE, ...)
}
\usage{
HTML.cormat(x,file=)
HTML.cormat(x, file = .HTML.file, digits = 2, append = TRUE, align = "center", caption = "", captionalign = "bottom", classcaption = "captiondataframe", classtable = "cormat", useCSS = TRUE, ...)
}

\arguments{
  \item{x}{ a correlation matrix }
  \item{file}{ target HTLM output}
  \item{digits}{ number of digits to use for rounding}
  \item{append}{ logical. If 'TRUE' output will be appended to 'file'; otherwise, it will overwrite the contents of 'file'}
  \item{align}{ alignment to be used: center, left or right}
  \item{caption}{ optional caption to append to the table }
  \item{captionalign}{ alignment to be used for the caption: could be bottom or top}
  \item{classcaption}{ CSS class to use for caption}
  \item{classtable}{ CSS class to be used for the whole table (in html <table> statement)}
  \item{useCSS}{ whether to use CSS or not for traffic highlighting}
  \item{\dots}{ ... }
}
\value{
	returns (invisibly) the input
}

\author{ Eric Lecoutre }
\note{ 
\dQuote{Highlighting traffic} is a simple technique which allows to have a visual representation of data. It is particularly well suited for correlation matrices in order to have at a glance the underlying (linear) structure of data.
If your output doesn't rely on CSS styles, you should use \code{useCSS=FALSE} option, whihc hard codes grey levels for correlations. 

For CSS uses, you can (re)define colours and other attributes for correlations in \code{seq(0,1,length=11)}-defined intervals. Some definitions could be equivalent, not showing any difference. You can, by example, redefine CSS so that only correlations greater than 0.9 are showned, and lower the size of cells, which could be usefull for veryu big datasets.
}



\seealso{ \code{\link{HTML}}}
\examples{
	tmpfic=HTMLInitFile(tempdir(),CSSFile="http://www.stat.ucl.ac.be/R2HTML/Pastel.css")
	data(iris)
	HTML(as.title("Fisher Iris dataset / Correlation matrix - normal matrix"),file=tmpfic)
	HTML(cor(iris[,1:4]), file=tmpfic)
	HTML(as.title("Fisher Iris dataset / Correlation matrix - traffic highlighting"),file=tmpfic)
	HTML.cormat(cor(iris[,1:4]), file=tmpfic)

	# File is generated, you can call the browser:
	\dontrun{browseURL(tmpfic)}
	
}
\keyword{ IO }
\keyword{ multivariate}

\eof
\name{HTML.data.frame}
\alias{HTML.data.frame}
\alias{HTML.matrix}
\title{ Write a data.frame (or matrix) to a HTML output}
\description{
  This function exports a data.frame to a HTML file. Many arguments allow to customize the layout of the HTML table.
}
\synopsis{HTML.data.frame(x, file = .HTML.file, Border = 1, innerBorder=0, classfirstline = "firstline",classfirstcolumn = "firstcolumn", classcellinside = "cellinside", digits = 2, append = TRUE, align = "center", caption = "", captionalign = "bottom", classcaption = "captiondataframe", classtable = "dataframe", ...)
}
\usage{
HTML.data.frame(x, file = .HTML.file, Border = 1, innerBorder=0,classfirstline = "firstline",\cr 
classfirstcolumn = "firstcolumn", classcellinside = "cellinside", digits = 2, \cr
append = TRUE, align = "center", caption = "", captionalign = "bottom", \cr
classcaption = "captiondataframe", classtable = "dataframe", ...)
HTML.data.frame(x,file=)
}

\arguments{
  \item{x}{ a data.frame}
  \item{file}{ target HTLM output}
  \item{Border}{ the size of the border around the table. Could be 0,1,... but also NULL}
  \item{innerBorder}{ the size of the border inside the table - see details}
  \item{classfirstline}{ CSS class for the first line (header - variable names) }
  \item{classfirstcolumn}{ CSS class for the first column (rownames)}
  \item{classcellinside}{ CSS class for others cells}
  \item{digits}{ number of digits to use for rounding}
  \item{append}{ logical. If 'TRUE' output will be appended to 'file'; otherwise, it will overwrite the contents of 'file'}
  \item{align}{ alignment to be used: center, left or right}
  \item{caption}{ optional caption to append to the table }
  \item{captionalign}{ alignment to be used for the caption: could be bottom or top}
  \item{classcaption}{ CSS class to use for caption}
  \item{classtable}{ CSS class to be used for the whole table (in html <table> statement)}
   \item{\dots}{ ...}
}
\details{
	For the moment, \code{HTML.matrix} and \code{HTML.data.frame} do have the same options.
	
	Tables are build using two different HTML tables, one beeing encapsulated within the other, which allows to have a table without borders inside but with a border outside. It is nevertheless recommanded to rely on CSS to obtain such results...
}
\value{
	no value returned.  
}

\author{ Eric Lecoutre}




\seealso{ \code{\link{HTML}}}
\examples{
tmpfic=HTMLInitFile(tempdir(),CSSFile="http://www.stat.ucl.ac.be/R2HTML/R2HTML.css")
data(iris)
HTML(as.title("Fisher Iris dataset"),file=tmpfic)
HTML(iris, file=tmpfic)
# File is generated, you can call the browser:
\dontrun{browseURL(tmpfic)}
}
\keyword{datasets}
\keyword{IO}

\eof
\name{HTML.function}
\alias{HTML.function}

\title{ Writes the code of a function to a target HTML file }
\description{
  Writes the code of a function to a target HTML file 
}
\usage{
HTML.function(x, file = .HTML.file, append=TRUE,...)
}

\arguments{
  \item{x}{ Name of a function }
  \item{file}{ target HTLM output}
  \item{append}{ logical. If 'TRUE' output will be appended to 'file'; otherwise, it will overwrite the contents of 'file'}
  \item{\dots}{ ...}
}
\details{
  The code of the function is written in the target HTML file, using HTML <XMP> tag. A CSS class called "function" is used to personalise the output.
}
\value{
	no value returned.  
}
\references{ }
\author{ Eric Lecoutre }

\note{ For a discussion about .HTML.file default value for file argument, refer to \code{\link{HTMLStart}} }

\seealso{  \code{\link{HTML}}}

\examples{

## Define a function and export it's code to the file /test.html.
## Target file may be changed when submitting this code...

myfile <- paste(tempfile(),".html",sep="")
myfun <- function(x){
	cat("\n Euclidian norm")
	return(sqrt(sum(x^2)))
 }
HTML.function(myfun,file=myfile)
cat("\n Test output written in: ",myfile)

}

\keyword{ print }
\keyword{ IO }
\keyword{ file }

\eof
\name{HTML.title}
\alias{HTML.title}
\alias{as.title}

\title{ Writes a title in a target HTML output }
\description{
  A title is a string with the S3 class "title". The function \code{as.title} gives this class to an object, so that title method of HTML could apply to it.
}
\usage{
HTML.title(x, HR = 2, CSSclass=NULL,file = .HTML.file,append=TRUE,...)
as.title(x)
}

\arguments{
  \item{x}{ string }
  \item{HR}{ rank attribute of the HTML <H?> tag }
  \item{CSSclass}{ CSS class to use for personalised reports }
  \item{file}{ the target HTML file }
  \item{append}{ logical. If 'TRUE' output will be appended to 'file'; otherwise, it will overwrite the contents of 'file'}
  \item{\dots}{ ... }
}
\details{
}
\value{
	no value returned.  
}
\references{  }
\author{ Eric Lecoutre }

\note{ For a discussion about .HTML.file default value for file argument, refer to \code{\link{HTMLStart}} }

\seealso{  \code{\link{HTML}} }

\examples{
## Write a title in the file /test.html.
## Target file may be changed when submitting this code...

myfile <- paste(tempfile(),".html",sep="")

tit1 <- as.title("This is method 1")

HTML(tit1, file=myfile)

HTML.title("This is method 2",file=myfile, HR=3)
cat("\n Test output written in: ",myfile)


}
\keyword{ print }
\keyword{ IO }
\keyword{ file }

\eof
\name{HTMLCSS}
\alias{HTMLCSS}

\title{ Insert HTML code to refer to an external CSS file }
\description{
  Allow to use CSS file in a report
}
\usage{
HTMLCSS(file = .HTML.file, append = TRUE, CSSfile = "R2HTML.css")
}

\arguments{
  \item{file}{ the target HTML file }
  \item{append}{ logical. If 'TRUE' output will be appended to 'file'; otherwise, it will overwrite the contents of 'file'}
  \item{CSSfile}{ name of the CSS file to refer }
}

\value{
	no value returned.    
}
\references{ For information about CSS, have a look at W3 web site http://www.w3.org/Style/CSS/ }
\author{ Eric Lecoutre }
\note{ }

 

\examples{
myfile <- file.path(tempdir(),"tmp.html")
HTMLCSS(myfile,CSSfile="myownCSS.CSS")
}
\keyword{ print }
\keyword{ IO }
\keyword{ file }

\eof
\name{HTMLChangeCSS}
\alias{HTMLChangeCSS}

\title{ Change the current CSS file for dynamic use of package }
\description{
  When using in dynamic mode, a call to \code{HTMLStart} copy the R2HTML.css file to the specified output directory (temp by default). \code{HTMLChangeCSS} copy a new CSS file to this destination (or to working directory). Then, the produced HTML files are now based on this new CSS.
  }
\usage{
HTMLChangeCSS(newCSS = "R2HTML", from = NULL)
}

\arguments{
  \item{newCSS}{ Name of the CSS to use (without the extension) }
  \item{from}{ Source directory where to search the CSS file }
}
\value{
	A boolean: wether this has been done or not.
}

\author{ Eric Lecoutre }

\note{ In order to work properly, this assumes you hae used R2HTML.css file (the default one), as this is this file which will be replaced by the new one.}



\seealso{ \code{\link{HTMLStart}}}

\examples{
\dontrun{
	HTMLStart()
	(x=diag(3))
	HTMLChangeCSS("Pastel")
	# refresh the browser
}
}
\keyword{ IO}
\keyword{ file }

\eof
\name{HTMLInitFile}
\alias{HTMLInitFile}
\alias{HTMLEndFile}

\title{ Begins / Ends a new HTML report output }
\description{
  Those two functions handle the beginning and the ending of a HTML report, by writing the HTML <body><head><title></title></head>...</body> tags and their options. When working manually, the user may need to use it's own functions or to explicitly write to a file using cat("", file=).
}

\usage{
HTMLInitFile(outdir = ".", filename = "index", extension = "html", HTMLframe = FALSE, BackGroundColor = "FFFFFF", BackGroundImg = "", Title = "R output", CSSFile = "R2HTML.css")
HTMLEndFile(file = .HTML.file)
}



\arguments{
  \item{outdir}{ directory to store the output }
  \item{filename}{ target HTML report filename }
  \item{extension}{ target HTML report extension (htm, html,...)  }
  \item{HTMLframe}{ should the output be handled by frames [boolean] }
  \item{BackGroundColor}{ option bgcolor for HTML tag <body>}
  \item{BackGroundImg}{ option background for HTML tag <body>}
  \item{Title}{ string to pass to HTML <title> tag  }
  \item{CSSFile}{ path and name of a CSS file to use }
  \item{file}{target HTML file to end}
}
\details{
}

\value{
	physical path of the main HTML file that will serve for the report.
}
\references{ }
\author{ Eric Lecoutre }

\note{ For a discussion about .HTML.file default value for file argument, refer to \code{\link{HTMLStart}} }

\seealso{  \code{\link{HTML}}}

\examples{
	# Store in target the name of a output file
	dir.create(file.path(tempdir(),"R2HTML"))
	target <- HTMLInitFile(file.path(tempdir(),"R2HTML"),"index", BackGroundColor="#BBBBEE")
	# Use target to write a dataframe
	HTML(as.title("Here is the data frame"),file=target)
	HTML("<br>Don't forget to use the CSS file in order to benefit from fixed size police",file=target)
	tmp <- as.data.frame(matrix(rnorm(100),ncol=10))
	HTML(tmp,file=target)
	HTMLEndFile()
}
\keyword{ print }
\keyword{ IO }
\keyword{ file }


\eof
\name{HTMLInsertGraph}
\alias{HTMLInsertGraph}

\title{ Insert a graph in a HTML report}
\description{
  Write the HTML <img> tag to an output, so that a existant graph could be displayed in the HTML report
}
\usage{
function(GraphFileName="",Caption="",GraphBorder=1,Align="center",WidthHTML=500,HeightHTML=NULL,file=.HTML.file,append=TRUE,...)
}

\arguments{
  \item{GraphFileName}{ Name of the target graph (GIF, JPEG or PNG) }
  \item{Caption}{ If non empty, text to be written under the graph, as it's caption}
  \item{GraphBorder}{ Size of the border, in pixels }
  \item{Align}{ Alignment of the graph (center, left or right) }
  \item{WidthHTML}{ Width of the image in HTML}
  \item{HeightHTML}{ Height of the image in HTML (NULL for not specified)}
  \item{file}{ Name of the target HTML file (the report) }
  \item{append}{ logical. If 'TRUE' output will be appended to 'file'; otherwise, it will overwrite the contents of 'file'}
  \item{\dots}{ \dots }
}
\details{
  The steps to add a graph to a HTML file are the following: first create the graph, by using a device convenient for web pages, such as GIF, JPEG or PNG. Ensure to write it in the same directory than the HTML file. Then call HTMLInsertGraph.
  }
\value{
	no value returned.  
}

\author{ Eric Lecoutre }

\seealso{ \code{\link{HTMLplot}}  }
\examples{

	directory=getwd()
	HTMLoutput=file.path(directory,"output.html")
	graph1="graph1.png"
	# Write graph to a file
	png(file.path(directory,graph1))
	plot(table(rpois(100,5)), type = "h", col = "red", lwd=10,main="rpois(100,lambda=5)")
	dev.off()
	# Insert graph to the HTML output
	HTMLInsertGraph(graph1,file=HTMLoutput,caption="Sample discrete distribution plot")
}

\keyword{ print }
\keyword{ IO }
\keyword{ file }



\eof
\name{HTMLStart}
\alias{HTMLStart}
\alias{HTMLStop}

\title{ Start / Stop  the automatic redirection of output to HTML files}
\description{
  Add the automatic redirection of output to an HTML file. The R session is modified in the following way: a new prompt is proposed (by default HTML>) and each parsed command is also evaluated using \code{\link{HTML}} generic method, so that the user benefits of both a normal and a HTML output.  Please read carefully the details below.
 }

\usage{
HTMLStart(outdir = tempdir(), filename = "index", extension = "html", echo = FALSE, autobrowse = FALSE, HTMLframe = TRUE, withprompt = "HTML> ", CSSFile = "R2HTML.css", BackGroundColor = "FFFFFF", BackGroundImg = "", Title = "R output") 
HTMLStop()
}


\arguments{
  \item{outdir}{ physical directory to store the output }
  \item{filename}{ name of the target HTML main file }
  \item{extension}{ extension of the target HTML file (htm, html,...) }
  \item{echo}{ should the parsed commands be written in the output? [boolean] }
  \item{autobrowse} {should the browser be invoked each time a command is issued? [boolean] }
  \item{HTMLframe}{ should the output have a HTML frame structure? [boolean]}
  \item{withprompt}{ prompt to display while using HTMLStart/HTMLStop}
  \item{CSSFile}{ path and name of a CSS file to use }
  \item{BackGroundColor}{ option bgcolor for HTML tag <body>}
  \item{BackGroundImg}{ option background for HTML tag <body>}
  \item{Title}{ string to pass to HTML <title> tag  }
}

\details{
The user may need to know the following points which describe how R2HTML does work:

- Each parsed command is evaluated and the returned value is passed to the generic function HTML. This evaluation is assured by addTaskCallback function, which is used to add a specific task each time R has to parse an expression. 

- A new environment called HTMLenv is build, where internal variables such as physical path are stored. This environment is not visible by the user. It is destroyed when calling \code{HTMLStop}.

- Inside the HTMLenv environment, a special variable may be of interest: \code{.HTML.file}, which contains the path to the default HTML target file. User should modify this variable, at his own risks.

- For internal uses, functions \code{fix} and \code{plot.new} are temporary replaced, by assigning them in your primary environment. Those copies are deleted when calling \code{HTMLStop}. If you close your session before calling \code{HTMLStop}, you will have to erase those function manually. If not, you may encounter troubles when editing a function or making a graph, as R2HTML functions refer to the environment HTMLenv...


}
\value{
	no useful output is returned.
}
\references{ }
\author{ Eric Lecoutre }

\note{ The argument \code{echo} is very usefull for teaching purpose.}

\seealso{  \code{\link{HTML}}}

\examples{

# Perform's one's own direct report

dir.create(file.path(tempdir(),"R2HTML"))
HTMLStart(file.path(tempdir(),"R2HTML"),HTMLframe=FALSE, Title="My report",autobrowse=FALSE)
as.title("This is my first title")
x <- 1
y<- 2
x+y
HTMLStop()


## Use for interactive teaching course
if (interactive()){
	dir.create(file.path(tempdir(),"R2HTML"))
	HTMLStart(file.path(tempdir(),"R2HTML"),echo=TRUE)
	as.title("Manipulation vectors")
	1:10
	sum(1:10)
	c(1:10,rep(3,4))
	HTMLStop()
}
}

\keyword{ print }
\keyword{ IO }
\keyword{ file }


\eof
\name{HTMLbr}
\alias{HTMLbr}
\alias{HTMLhr}
\alias{HTMLli}

\title{ Facility functions to write HTML code }
\description{
  Write <br>, <li> and <hr> tags, which are often used, to an output file.
}
\usage{
HTMLbr(x=1,file = .HTML.file,append=TRUE)
HTMLli(txt="",file = .HTML.file,append=TRUE)
HTMLhr(file = .HTML.file, Width = "100\%", Size = "1",CSSclass=NULL,append=TRUE)
}

\arguments{
  \item{x}{ number of <br> to put }
  \item{txt}{ text to appear after the <li> tag }
  \item{file}{ HTML target output file}
  \item{Width}{ value of the width HR optional argument, in pixel or percent}  
  \item{Size}{ value of the size HR optional argument}  
  \item{append}{ logical. If 'TRUE' output will be appended to 'file'; otherwise, it will overwrite the contents of 'file'}
  \item{CSSclass}{ CSS class to use for personalised reports }
}

\value{
	no value returned.
}

\references{}
\author{ Eric Lecoutre}

\note{ For a discussion about .HTML.file default value for file argument, refer to \code{\link{HTMLStart}} }

 

\seealso{  \code{\link{HTML}}}

\examples{

## Insert a line to a HTML file
## Change the path/name of the file to redirect to your test file

myfile <- paste(tempfile(),".html",sep="")
HTMLhr(file=myfile)
cat("\n Test output written in: ",myfile)

}
\keyword{ print }
\keyword{ IO }
\keyword{ file }

\eof
\name{HTMLplot}
\alias{HTMLplot}

\title{ Insert a graphic into an HTML output }
\description{
  Exports the active graphic to a JPEG or GIF file and add it to a target HTML output, by writing the <IMG> tag.
}
\usage{
"HTMLplot" <- function (Caption = "", file = .HTML.file, GraphDirectory = ".", 
    GraphFileName = "", GraphSaveAs = "png", GraphBorder = 1, 
    Align = "center", width=500,height=NULL,WidthHTML=500,HeightHTML=NULL,append=TRUE,...) 
}

\arguments{
  \item{Caption}{text to be placed below the graphic, as a caption}
  \item{file}{ the target HTML file }
  \item{GraphDirectory}{ path where file should be stored }
  \item{GraphFileName}{ name of the file to produce (could be missing) }
  \item{GraphSaveAs}{ an existing exportation device, such as jpg or gif }
  \item{GraphBorder}{ HTML border option for the <IMG> tag }
  \item{Align}{ HTML align option for the <IMG> tag}
  \item{width}{width of the image to create (passed to the driver)}
  \item{height}{height of the image to create (passed to the driver) (NULL: not specified)}
  \item{WidthHTML}{ Width of the image in HTML}
  \item{HeightHTML}{ Height of the image in HTML (NULL for not specified)}
  \item{append}{ logical. If 'TRUE' output will be appended to 'file'; otherwise, it will overwrite the contents of 'file'}
  \item{\dots}{ ... }
}
\details{
Note that this function is coded to work automatically when using automatic exportation with \code{\link{HTMLStart}}. When using manualy, user should pay attention to the GraphDirectory option, so that graph files are in the same directory as HTML output files. When using to write reports in a non interactive way, first generate the graphic using a device and then use \code{\link{HTMLInsertGraph}}.
}
\value{
	no value returned.  
}
\references{}

\author{ Eric Lecoutre }
\note{ For a discussion about .HTML.outdir and HTLMenv, refer to \code{\link{HTMLStart}} }

\seealso{ \code{\link{HTMLStart}}, \code{\link{HTMLInsertGraph}}}

\examples{

## Plots a graphic and insert it into the file /test.html.
## Target file and also graph directory should be changed when submitting this code...

myfile <- paste(tempfile(),".html",sep="")
plot(sin, -pi, 2*pi,main="Sinus")
# HTMLplot(file=myfile,GraphDirectory="/",Caption="Look at this curve!")
}

\keyword{ print }
\keyword{ IO }
\keyword{ file }


\eof
\name{HTMLstem}
\alias{HTMLstem}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Insert a stem-and-leaf plot in the HTML output}
\description{
  Insert a stem-and-leaf plot in the HTML output.
}
\usage{
HTMLstem(x, file = .HTML.file, append = TRUE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{  a numeric vector.}
  \item{file}{ the target HTML file  }
  \item{append}{logical. If 'TRUE' output will be appended to 'file'; otherwise, it will overwrite the contents of 'file'}
  \item{\dots}{ any other argument that may be passed to \code{stem}, such as scale,...}
}
\details{
 As \code{stem} internal function does not return anything but directly print to console, there is no way to automatically export it to the HTML output. Thus, \code{HTMLstem} simply captures the output and write it to the HTML file. When using the package in a interactive way, you should call \code{HTMLstem}.
}
\value{
	no value returned.  }

\author{ Eric Lecoutre}


\seealso{ \code{\link{stem}},\code{\link{HTML}}}
\examples{
	data(islands)
	tmpfic=paste(tempfile(),"html",sep=".")
	HTMLstem(log10(islands),tmpfic)
	cat("\n stem-and-leaf writen to:", tmpfic,"\n")
}
\keyword{ IO }
\keyword{ univar }

\eof
\name{HTLMReplaceNA}
\alias{HTMLReplaceNA}
\alias{HTMLCommand}
\alias{HTMLcode}
\title{Internal R2HTML functions}
\description{   Internal R2HTML functions}
\usage{
HTMLReplaceNA(Vec, Replace = " ")
HTMLCommand(x, file = .HTML.file, Num = "", menu = FALSE, target= "index<-main.html", append = TRUE, ...)
HTMLcode(x,...)
}
\arguments{
  \item{Vec}{ string }
  \item{Replace}{ string to use for missing values }
  \item{x}{ a string corresponding to a R command}
  \item{file}{ the target HTML file }
  \item{Num}{ number of the command}
  \item{menu}{}
  \item{target}{}
  \item{append}{ logical. If 'TRUE' output will be appended to 'file'; otherwise, it will overwrite the contents of 'file'}
  \item{\dots}{...}
}
\details{
     These are not to be called by the user.
}
\examples{

}
\keyword{misc}

\eof
\name{RweaveHTML}
\alias{RweaveHTML}
\alias{RweaveHTMLOptions}
\alias{RweaveHTMLFinish}
\alias{RweaveHTMLWritedoc}
\alias{RweaveHTMLSetup}
\alias{RweaveHTMLRuncode}
\alias{SweaveSyntaxHTML}

\title{ A driver to parse HTML noweb files with Sweave tool}
\description{
   This driver parses HTML files containing R code and replace pieces of code with their output. Graphs are incorporated as png.
}
\usage{
RweaveHTML()
}
%- maybe also 'usage' for other objects documented here.
\details{
}
\value{
	None value is returned. From a .snw noweb file, the corresponding .html is produced (as eventuals png files for graphs).
}

\author{ Eric Lecoutre }
\note{
In order to work properly, noweb codes have to be located at the beginning of a line (no indentation). See samples in the samples directory of the package.
}


\seealso{ \code{\link[tools]{Sweave}}}
\examples{

\dontrun{
library(tools)
Sweave("file.snw",driver=RweaveHTML)
}
}
\keyword{ IO}
\keyword{ file}

\eof
